from Products.CMFRelation import cmfrelations_globals
from Products.CMFCore.DirectoryView import addDirectoryViews, registerDirectory,createDirectoryView
from Products.CMFCore.TypesTool import  ContentFactoryMetadata, FactoryTypeInformation
from Products.CMFCore.utils import getToolByName
from Products.CMFExample import cmfexamples_globals
from Products.ExternalMethod import ExternalMethod

from Globals import package_home
import os, string
from StringIO import StringIO
import zLOG

def log_deprecated(message,summary='Deprecation Warning',severity=zLOG.WARNING):
    """ Deprecated Log Method """
    zLOG.LOG('CMF Relations: ',severity,summary,message)


def log(message,summary='',severity=0):
    """ Generic Log Method """
    zLOG.LOG('CMF Relations: ',severity,summary,message)



def install_skin(self, outStream, skinName, skinFolder):
    """ """
    skinstool=getToolByName(self, 'portal_skins')
    path = skinstool.getSkinPath('Plone Default') 
    if not path:
        outStream.write('Plone skin not found, aborting\n')
        return
    path = map( string.strip, string.split( path,',' ) )

    if type(skinFolder)==type(''):
        skinFolder=(skinFolder, )

    for folder in skinFolder:
        try:
            path.insert( path.index( 'custom')+1, folder )
        except ValueError:
            path.append(folder)
        
    path = string.join( path, ', ' )
    skinstool.addSkinSelection( skinName, path )
    
def install(self):
    # log(self)
    
    out=StringIO()
    addPloneTool=self.manage_addProduct['CMFRelation'].manage_addTool
    addPloneTool('Relations Tool', None)
    
    #add skin
    skinstool=getToolByName(self, 'portal_skins')
    addDirectoryViews(skinstool, 'skins', cmfrelations_globals)
    install_skin(self, out, 'CMFRelation', ['cmfrelation'])
    
    #adds the directory views to the BEGINING of all the other skins
    # required to overwrite folder_rename
    skin_map=skinstool._getSelections()
    for skin_name, skin_path in skinstool.getSkinPaths():
        if skin_name!='CMFRelation':
            skin_map[skin_name]='cmfrelation,' + skin_path    
    out.write('Successfully installed the CMFRelation tool.\n')
    return out.getvalue()
  